/// <reference types="mongoose" />
import { Schema } from 'mongoose';
export interface MongooseOptions {
    mongooseSchema: Schema;
}
export interface NodesworkMongooseSchemaClass {
    new (): NodesworkMongooseSchema;
    Config(): NodesworkMongooseSchemaClass;
    Schema(schema: object): NodesworkMongooseSchemaClass;
    Plugin(): NodesworkMongooseSchemaClass;
    Index(): NodesworkMongooseSchemaClass;
    Virtual(): NodesworkMongooseSchemaClass;
    Pre(): NodesworkMongooseSchemaClass;
    Post(): NodesworkMongooseSchemaClass;
    MongooseOptions(): MongooseOptions;
    MongooseSchema(): Schema;
}
export declare class NodesworkMongooseSchema {
    static Config(): NodesworkMongooseSchemaClass;
    static Schema(schema: object): NodesworkMongooseSchemaClass;
    static Plugin(): NodesworkMongooseSchemaClass;
    static Index(): NodesworkMongooseSchemaClass;
    static Virtual(): NodesworkMongooseSchemaClass;
    static Pre(): NodesworkMongooseSchemaClass;
    static Post(): NodesworkMongooseSchemaClass;
    static MongooseOptions(): MongooseOptions;
    static MongooseSchema(): Schema;
    static $SCHEMA: object;
    static _mongooseOptions: MongooseOptions;
}
