import { Schema } from 'mongoose';
export declare const MINIMAL = "MINIMAL";
export interface ModelConfig {
    levels?: string[];
}
declare module 'mongoose' {
    interface Schema {
        levelMap?: {
            [name: string]: string[];
        };
        levels: string[];
    }
}
export declare function dataLevelPlugin(schema: Schema, options: ModelConfig): void;
